//	Copyright (c) 2008 itok ( http://itok.jp/ , http://110k.net/ )
//	All rights reserved.
//
//	Redistribution and use in source and binary forms, with or without modification, 
//	are permitted provided that the following conditions are met:
//
//	- Redistributions of source code must retain the above copyright notice, 
//	  this list of conditions and the following disclaimer.
//	- Redistributions in binary form must reproduce the above copyright notice, 
//	  this list of conditions and the following disclaimer in the documentation 
//	  and/or other materials provided with the distribution.
//	- Neither the name of itok nor the names of its contributors may be used to endorse 
//	  or promote products derived from this software without specific prior written permission.
//
//	THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS 
//	AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, 
//	INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY 
//	AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. 
//	IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, 
//	INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES 
//	(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; 
//	LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) 
//	HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, 
//	STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
//	ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, 
//	EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

#import <Cocoa/Cocoa.h>
@class PURequest;

enum {
	kPUMultiRequest_Success,	//!< 成功
	kPUMultiRequest_Cancel,		//!< キャンセル
	kPUMultiRequest_Fail,		//!< 失敗
};

/**
 *	@brief	複数リクエスト管理
 */
@interface PUMultiRequest : NSObject 
{
	NSMutableArray* m_reqs;
	int				m_total;
	PURequest*		m_curReq;
	id				m_delegate;
	BOOL			m_errOccurred;
}

/**
 *	@brief	開始
 */
-(void) start:(NSArray*)reqs;

/**
 *	@brief	キャンセル
 */
-(void) cancel;

-(id) delegate;
-(void) setDelegate:(id)delegate;

@end

@interface NSObject (PUMultiRequestDelegate)

/**
 *	@brief	全リクエスト完了通知
 */
-(void) multiRequestDidCompleted:(PUMultiRequest*)multiReq result:(int)result;

/**
 *	@brief	1リクエスト完了通知
 */
-(void) multiRequest:(PUMultiRequest*)multiReq didCompletedOne:(PURequest*)request withProgress:(double)progress;

/**
 *	@brief	1リクエスト開始確認
 */
-(BOOL) multiRequest:(PUMultiRequest*)multiReq willStartOne:(PURequest*)request;

@end
