//
//  PZTest.m
//  iPhotoZou
//
//  Created by itok on 08/01/29.
//  Copyright 2008 itok. All rights reserved.
//

#import "PUTest.h"
#import "PhotoZou.h"
#import "Fotolife.h"
#import "Flickr.h"
#import "PUMultiRequest.h"

@implementation PUTest

-(void) awakeFromNib
{
	m_albumDic = [[NSMutableDictionary alloc] init];
//	[NSApp runModalForWindow:o_window];
	
	[FlickrRequest setToken:@"72157604967069675-cb2309b1cf279031"];
}

-(void) login
{
	NSUserDefaults* defaults = [NSUserDefaults standardUserDefaults];
	NSString* username = [defaults objectForKey:@"username"];
	NSString* password = [defaults objectForKey:@"password"];
	if (!(username && [username length] > 0 && password && [password length] > 0)) {
		return;
	}
	
	[PURequest setUsername:username];
	[PURequest setPassword:password];
}

-(IBAction) nop:(id)sender
{
	Flickr_Auth_GetFrob* req = [[Flickr_Auth_GetFrob alloc] init];
//	Flickr_Auth_GetToken* req = [[Flickr_Auth_GetToken alloc] initWithFrob:@"72157604967577065-87c2f3eeb9d84691-877008"];
	[req setDelegate:self];
	[req start];
	return;
#if 0
	[self login];
	PhotoZou_Nop* nop = [[PhotoZou_Nop alloc] init];
	[nop setDelegate:self];
	[nop start];
#else
	[self login];
	Fotolife_Atom* atom = [[Fotolife_Atom alloc] init];
	[atom setDelegate:self];
	[atom start];
#endif
}
-(IBAction) upload:(id)sender
{
	[self login];
	
//	int albumId = [[[m_albumDic objectForKey:[_albumMenu objectAtIndex:_albumIndex]] valueForKey:@"album_id"] intValue];
	NSOpenPanel* op = [NSOpenPanel openPanel];
//	[op setAllowsMultipleSelection:YES];
	if ([op runModalForTypes:[NSArray arrayWithObjects:@"jpeg", @"jpg", nil]] == NSOKButton) {
#if 1
		Flickr_Upload* req = [[Flickr_Upload alloc] init];
		[req setValue:[NSURL fileURLWithPath:[[op filenames] objectAtIndex:0]] forKey:@"fileUrl"];
		[req setValue:@"image/jpeg" forKey:@"contentType"];
		[req setDelegate:self];
		[req start];
#else
#if 1
		Fotolife_AtomPost* req = [[Fotolife_AtomPost alloc] init];
		[req setValue:[NSURL fileURLWithPath:[[op filenames] objectAtIndex:0]] forKey:@"fileUrl"];
		[req setValue:@"image/jpeg" forKey:@"contentType"];
		[req setDelegate:self];
		[req start];
//		[req release];
#else
		PhotoZou_PhotoAdd* req;
		NSMutableArray* reqs = [NSMutableArray array];
		int i;
		for (i = 0; i < [[op filenames] count]; i++) {
			req = [[PhotoZou_PhotoAdd alloc] init];
			[req setValue:[NSURL fileURLWithPath:[[op filenames] objectAtIndex:i]] forKey:@"fileUrl"];
			[req setValue:[NSNumber numberWithInt:albumId] forKey:@"albumId"];
			[req setValue:@"image/jpeg" forKey:@"contentType"];
			[reqs addObject:req];
			[req release];
//			[req setDelegate:self];
//			[req start];
		}
		
		PUMultiRequest* mreq = [[PUMultiRequest alloc] init];
		[mreq setDelegate:self];
		[mreq start:reqs];
#endif
#endif
	}
}

-(IBAction) album:(id)sender
{
	[self login];
	PhotoZou_PhotoAlbum* album = [[PhotoZou_PhotoAlbum alloc] init];
	[album setDelegate:self];
	[album start];
}

-(void) request:(PURequest*)request didCompletedWithResult:(int)code
{
	NSLog(@"completedWithResult %d", code);
//	NSLog(@"%s", [request replyContent]);

	if ([request isKindOfClass:[PhotoZou_PhotoAlbum class]]) {
		NSArray* albums = [request responseData]; 	
		NSEnumerator* enume = [albums objectEnumerator];
		PZAlbum* album;
		while (album = [enume nextObject]) {
			[m_albumDic setObject:album forKey:[album valueForKey:@"name"]];
		}
		[self setValue:[m_albumDic allKeys] forKey:@"albumMenu"];	
	} else {
		NSLog(@"%@", [[request responseData] description]);
#if 0
		NSData* data = [request responseData];
		NSXMLDocument* xml = [[NSXMLDocument alloc] initWithData:data options:0 error:nil];
		if (xml) {
			NSLog(@"%@", [xml description]);
			NSLog(@"%@", [[[NSString alloc] initWithData:data encoding:NSUTF8StringEncoding] autorelease]);
		[xml release];
#endif
	}	
	
	[request release];
}

-(void) multiRequestDidCompleted:(PUMultiRequest*)multiReq
{
	NSLog(@"completed");	
	[multiReq release];
}

-(void) multiRequest:(PUMultiRequest*)multiReq didCompletedOne:(PURequest*)request withProgress:(double)progress
{
	NSLog(@"%@", [[request responseData] description]);
	NSLog(@"progress %f", progress);
}

-(BOOL) multiRequest:(PUMultiRequest*)multiReq willStartOne:(PURequest*)request
{
	return YES;
}

@end
